cart/urls.py
from django.urls import path
from . import views

app_name = 'cart'

urlpatterns = [
    path('', views.cart, name='cart'),
    path('add/<int:product_id>', views.cart_add, name='cart_add'),
    path('remove/<int:product_id>', views.cart_remove, name='cart_remove'),
    path('update/', views.cart_update, name='cart_update')
]

company/urls.py
from django.urls import path
from . import views

app_name = 'company'

urlpatterns = [
    path('', views.home, name='home'),
    path('about/', views.about, name='about')
]

core/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from core import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('company.urls', namespace='company')),
    path('shop/', include('shop.urls', namespace='shop')),
    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('cart/', include('cart.urls', namespace='cart')),
    path('orders/', include('orders.urls', namespace='orders')),
    path('checkout/', include('checkout.urls', namespace='checkout')),
]

shop/urls.py
from django.urls import path
from . import views

app_name = 'shop'

urlpatterns = [
    path('', views.shop, name='shop'),
    path('search/', views.search, name='search'),
    path('category/<slug:slug>/', views.shop, name='category_filter'),
    path('manufacturer/<slug:slug>/', views.shop, name='manufacturer_filter'),
    path('product_details/<slug:slug>/', views.product_details, name='product'),
    path('review/<slug:slug>/', views.add_review, name='review'),
    path('wishlist/', views.liked, name='liked'),
    path('add-to-wishlist/', views.add_to_wishlist, name='add_to_wishlist'),  # For add to wishlist
]

shop/models.py
from django.db import models
from django.urls import reverse
from django.conf import settings

User = settings.AUTH_USER_MODEL


class Category(models.Model):
    sub_category = models.ForeignKey('self', on_delete=models.CASCADE, related_name='scategory', null=True, blank=True)
    is_sub = models.BooleanField(default=False)
    is_featured = models.BooleanField(default=False)
    name = models.CharField(max_length=200)
    slug = models.SlugField(max_length=200, unique=True)

    class Meta:
        ordering = ('name',)
        verbose_name = 'Category'
        verbose_name_plural = 'Categories'

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('shop:category_filter', args={self.slug})


class Manufacturer(models.Model):
    name = models.CharField(max_length=200)
    slug = models.SlugField(max_length=200, unique=True)

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('shop:manufacturer_filter', args={self.slug})


class Product(models.Model):
    TAG_CHOICES = (
        ('', ''),
        ('out-of-stock', 'Hot'),
        ('new', 'New'),
        ('price-dec', 'Auction'),
    )
    name = models.CharField(max_length=200)
    slug = models.SlugField(max_length=200, unique=True)
    tag = models.CharField(max_length=300, choices=TAG_CHOICES, blank=True, null=True)
    category = models.ManyToManyField(Category, related_name='products')
    manufacturer = models.ForeignKey(Manufacturer, related_name='pmanufacturer', on_delete=models.CASCADE)
    short_descriptions = models.TextField()
    descriptions = models.TextField()
    price = models.DecimalField(decimal_places=2, max_digits=6)
    discount_price = models.FloatField(blank=True, null=True)
    quantity = models.IntegerField(default=1)
    available = models.BooleanField(default=True)
    is_featured = models.BooleanField(default=False)
    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now=True)

    class Meta:
        ordering = ('updated',)
        verbose_name = 'Product'
        verbose_name_plural = 'Products'

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('shop:product', args={self.slug})


class ProductImages(models.Model):
    product = models.ForeignKey(Product, default=None, related_name='images', on_delete=models.CASCADE)
    image = models.ImageField(upload_to='products/%Y/%m/%d', blank=True)


class ProductFeatures(models.Model):
    product = models.ForeignKey(Product, default=None, related_name='features', on_delete=models.CASCADE)
    text = models.CharField(max_length=400)


class Review(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    product = models.ForeignKey(Product, on_delete=models.CASCADE, null=True)
    date = models.DateTimeField(auto_now_add=True)
    full_name = models.CharField(max_length=200)
    text = models.TextField(max_length=3000, blank=True)

    def __str__(self):
        return self.user.full_name


class Wishlist(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE, null=True)
    product = models.ForeignKey(Product, on_delete=models.CASCADE)

shop/forms.py
from django import forms

from .models import Review


class ReviewForm(forms.ModelForm):

    class Meta:
        model = Review
        fields = ('full_name', 'text')

shop/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.contrib import messages
from .forms import ReviewForm
from .models import Category, Product, Manufacturer, Review, Wishlist
from django.urls import resolve
from django.core.paginator import Paginator
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_POST
from django.http import HttpResponse
from cart.forms import CartAddForm
from django.db.models import Q


def shop(request, slug=None):
    products = Product.objects.filter(available=True)
    categories = Category.objects.filter(is_sub=False)
    manufacturer = Manufacturer.objects.all()
    if slug:
        url_name = resolve(request.path).url_name
        if url_name == 'category_filter':
            category = get_object_or_404(Category, slug=slug)
            products = products.filter(category=category)
        elif url_name == 'manufacturer_filter':
            manufacture = get_object_or_404(Manufacturer, slug=slug)
            products = products.filter(manufacturer=manufacture)
    paginator = Paginator(products, 9)  # Show 9 contacts per page.
    page_number = request.GET.get('page')
    page_obj = paginator.get_page(page_number)
    wishlisted_list = []
    if request.user.is_authenticated:
        wishlisted_list = list(
            Wishlist.objects.filter(user_id=request.user).values_list('product_id', flat=True).order_by('product_id'))
    form = CartAddForm()
    context = {
        'products': page_obj,
        'categories': categories,
        'manufacturer': manufacturer,
        'wishlisted_list': wishlisted_list,
        'form': form
    }

    return render(request, 'shop/shop.html', context)


def product_details(request, slug):
    form = CartAddForm()
    review_form = ReviewForm()
    review = Review.objects.filter(product__slug=slug)
    product = get_object_or_404(Product, slug=slug)
    if product:
        category_slug = [pr.slug for pr in product.category.all()]
        related_products = Product.objects.filter(available=True, category__slug__in=category_slug)
    wishlisted_list = []
    if request.user.is_authenticated:
        wishlisted_list = list(
            Wishlist.objects.filter(user_id=request.user).values_list('product_id', flat=True).order_by('product_id'))
    context = {
        'product': product,
        'review': review,
        'related_products': related_products,
        'wishlisted_list': wishlisted_list,
        'form': form,
        'review_form': review_form
    }
    return render(request, 'shop/product-details.html', context)


@login_required
@require_POST
def add_review(request, slug):
    form = ReviewForm(request.POST)
    product = get_object_or_404(Product, slug=slug)
    if form.is_valid():
        cd = form.cleaned_data
        review = Review(user=request.user, product=product, full_name=cd['full_name'], text=cd['text'])
        review.save()
        messages.success(request, 'thanks!', 'success')
    else:
        messages.success(request, 'please fill out the form correctly!', 'danger')
    return redirect('shop:product', slug)


@login_required
def liked(request):
    wishlist = {}
    if request.method == "GET":
        if request.user.is_authenticated:
            wishlist = Wishlist.objects.filter(user_id=request.user.pk)
        else:
            print("Please login")
            return HttpResponse("login")

    return render(request, template_name='shop/wishlist.html', context={"wishlist": wishlist})


def is_ajax(request):
    return request.META.get('HTTP_X_REQUESTED_WITH') == 'XMLHttpRequest'


@login_required
def add_to_wishlist(request):
    if is_ajax(request=request) and request.POST and 'attr_id' in request.POST:
        if request.user.is_authenticated:
            data = Wishlist.objects.filter(user_id=request.user.pk, product_id=int(request.POST['attr_id']))
            if data.exists():
                data.delete()
            else:
                Wishlist.objects.create(user_id=request.user.pk, product_id=int(request.POST['attr_id']))
    else:
        print("No Product is Found")

    return redirect("shop:shop")


def search(request):
    products = Product.objects.filter(available=True)
    query = request.GET.get('q')
    if query:
        products = products.filter(
            Q(name__icontains=query) | Q(short_descriptions__icontains=query) | Q(descriptions__icontains=query))
        return render(request, 'shop/search.html', {'products': products,'query':query})
    else:
        return redirect("shop:shop")

shop/templates/shop/search.html
{% extends 'base.html' %}
{% load static %}
{%block content %}
<!-- Breadcrumbs -->
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<div class="breadcrumbs">
    <div class="container">
        <div class="row">
            <div class="col-12">
                <div class="bread-inner">
                    <ul class="bread-list">
                        <li><a href="{% url 'company:home'%}">Home<i class="ti-arrow-right"></i></a></li>
                        <li class="active">Shop</li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- End Breadcrumbs -->
{% if products%}
<div class="container" style="margin-top:50px">
    <div class="row">
        <div class="col-12">
            <div class="section-title">
                <h2>Search Results</h2>
            </div>

        </div>
    </div>
    <!-- Product Style -->
    <section class="product-area shop-sidebar shop section">
        <div class="container">
            <div class="row">
                <div class="col-lg-9 col-md-8 col-12">
                    <div class="row">
                        {% for product in products %}
                        <div class="col-lg-4 col-md-6 col-12">
                            <div class="single-product">
                                <div class="product-img">
                                    <a href="{{product.get_absolute_url}}">
                                        <img class="default-img" src="{{product.images.first.image.url}}" alt="#">
                                        {% if product.tag %}
                                        <span class="{{product.tag}}">{{product.get_tag_display}}</span>
                                        {% endif %}
                                    </a>
                                    <div class="button-head">
                                        <div class="product-action">
                                            <a data-toggle="modal" data-target="#exampleModal" title="View Product"
                                               href="{{product.get_absolute_url}}"><i class=" ti-eye"></i><span>View Product</span></a>
                                            {% if user.is_authenticated %}
                                            {% if product.pk in wishlisted_list %}
                                            <span id="like" attr_id="{{product.pk}}" class="ti-heart-broken"
                                                  title="Remove From Wishlist"
                                                  action_url="{% url 'shop:add_to_wishlist' %}"></span>
                                            {% else %}
                                            <span id="like" attr_id="{{product.pk}}" class="ti-heart "
                                                  title="Add To Wishlist"
                                                  action_url="{% url 'shop:add_to_wishlist' %}"></span>
                                            {% endif %}
                                            {% endif %}
                                        </div>

                                        <div class="product-action-2">
                                            <form action="{% url 'cart:cart_add' product.id %}" method="post"
                                                  id="cart-form">
                                                {% csrf_token %}
                                                <a title="Add to cart" href="javascript:{}"
                                                   onclick="document.getElementById('cart-form').submit();">Add to
                                                    cart</a>
                                            </form>

                                        </div>
                                    </div>
                                </div>
                                <div class="product-content">
                                    <h3><a href="{{product.get_absolute_url}}">{{product.name}}</a></h3>
                                    <div class="product-price">
                                        {% if product.discount_price %}
                                        <span class="old">${{product.price}}</span>
                                        <span>${{product.discount_price}}</span>
                                        {% else %}
                                        <span>${{product.price}}</span>
                                        {% endif %}

                                    </div>
                                </div>
                            </div>
                        </div>
                        {% endfor %}
                    </div>
                </div>

            </div>
        </div>
    </section>
    <!--/ End Product Style 1  -->
</div>

{%else%}

<div class="container" style="margin-top:100px">
    <div class="row">
        <div class="col-12">
            <div class="section-title">
                <h2>can find anything in "{{query}}"</h2>
            </div>
            <div class="section-title">
                Your search did not return any results - please try another search term.
            </div>
        </div>
    </div>
</div>
{%endif%}


{% endblock %}

{% block footer %}
<script src="{% static 'shop/js/like.js' %}"></script>
<script src="{% static 'frontend/js/jquery.cookie.min.js' %}"></script>

{% endblock%}

shop/templates/shop/shop.html
{% extends 'base.html' %}
{% load static %}
{%block content %}
<!-- Breadcrumbs -->
<div class="breadcrumbs">
    <div class="container">
        <div class="row">
            <div class="col-12">
                <div class="bread-inner">
                    <ul class="bread-list">
                        <li><a href="{% url 'company:home'%}">Home<i class="ti-arrow-right"></i></a></li>
                        <li class="active">Shop</li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- End Breadcrumbs -->

<!-- Product Style -->
<section class="product-area shop-sidebar shop section">
    <div class="container">
        <div class="row">
            <div class="col-lg-3 col-md-4 col-12">
                <div class="shop-sidebar">
                        <!-- Single Widget -->
                        <div class="single-widget category">
                            <h3 class="title">Categories</h3>
                            <ul class="categor-list">
                                {% for category in categories %}
                                    <li><a href="{{ category.get_absolute_url }}">{{ category.name }}</a></li>
                                {% endfor %}
                            </ul>
                        </div>
                        <!--/ End Single Widget -->
                        <!-- Single Widget -->
                        <div class="single-widget recent-post">
                            <h3 class="title">Recent post</h3>
                            {% for product in products|slice:":3" %}
                            <!-- Single Post -->
                            <div class="single-post first">
                                <div class="image">
                                    <img src="{{product.images.first.image.url}}" alt="#">
                                </div>
                                <div class="content">
                                    <h5><a href="{{product.get_absolute_url}}">{{product.name}}</a></h5>

                                    <p class="price">
                                     {% if product.discount_price %}
                                        ${{product.discount_price}}
                                    {% else %}
                                        ${{product.price}}
                                    {% endif %}
                                        </p>
                                </div>
                            </div>
                            <!-- End Single Post -->
                            {% endfor %}
                        </div>
                        <!--/ End Single Widget -->
                        <!-- Single Widget -->
                        <div class="single-widget category">
                            <h3 class="title">Manufacturers</h3>
                            <ul class="categor-list">
                                {% for manufact in manufacturer %}
                                    <li><a href="{{ manufact.get_absolute_url }}">{{ manufact.name }}</a></li>
                                {% endfor %}
                            </ul>
                        </div>
                        <!--/ End Single Widget -->
                </div>
            </div>
            <div class="col-lg-9 col-md-8 col-12">
                <div class="row">
                    {% for product in products %}
                        <div class="col-lg-4 col-md-6 col-12">
                        <div class="single-product">
                            <div class="product-img">
                                <a href="{{product.get_absolute_url}}">
                                    <img class="default-img" src="{{product.images.first.image.url}}" alt="#">
                                    {% if product.tag %}
                                        <span class="{{product.tag}}">{{product.get_tag_display}}</span>
                                    {% endif %}
                                </a>
                                <div class="button-head">
                                    <div class="product-action">
                                        <a data-toggle="modal" data-target="#exampleModal" title="View Product" href="{{product.get_absolute_url}}"><i class=" ti-eye"></i><span>View Product</span></a>
                                        {% if user.is_authenticated %}
                                        {% if product.pk in wishlisted_list %}
                                        <span id="like" attr_id="{{product.pk}}" class="ti-heart-broken" title="Remove From Wishlist" action_url="{% url 'shop:add_to_wishlist' %}"></span>
                                        {% else %}
                                        <span id="like" attr_id="{{product.pk}}" class="ti-heart " title="Add To Wishlist" action_url="{% url 'shop:add_to_wishlist' %}"></span>
                                        {% endif %}
                                        {% endif %}
                                    </div>

                                    <div class="product-action-2">
                                        <form action="{% url 'cart:cart_add' product.id %}" method="post" id="cart-form">
                                            {% csrf_token %}
                                            <a title="Add to cart" href="javascript:{}" onclick="document.getElementById('cart-form').submit();">Add to cart</a>
                                        </form>

                                    </div>
                                </div>
                            </div>
                            <div class="product-content">
                                <h3><a href="{{product.get_absolute_url}}">{{product.name}}</a></h3>
                                <div class="product-price">
                                    {% if product.discount_price %}
                                        <span class="old">${{product.price}}</span>
                                        <span>${{product.discount_price}}</span>
                                    {% else %}
                                        <span>${{product.price}}</span>
                                    {% endif %}

                                </div>
                            </div>
                        </div>
                    </div>
                    {% endfor %}
                    <div class="col-12">
									<!-- Pagination -->
									<div class="pagination">
										<ul class="pagination-list">
                                            {% if products.has_previous %}
											    <li><a href="?page={{ products.previous_page_number }}"><i class="ti-arrow-left"></i></a></li>
											    <li><a href="?page={{ products.previous_page_number }}">{{ products.previous_page_number }}</a></li>
                                            {% endif %}
											<li class="active"><a href="#">{{ products.number }}</a></li>
                                            {% if products.has_next %}
											    <li><a href="?page={{ products.next_page_number }}">{{ products.next_page_number }}</a></li>
											    <li><a href="?page={{ products.next_page_number }}"><i class="ti-arrow-right"></i></a></li>
                                            {% endif %}
										</ul>
									</div>
									<!--/ End Pagination -->
                            </div>

                </div>
            </div>

        </div>
    </div>
</section>
<!--/ End Product Style 1  -->



{% endblock %}

{% block footer %}
<script src="{% static 'shop/js/like.js' %}"></script>
<script src="{% static 'frontend/js/jquery.cookie.min.js' %}"></script>

{% endblock%}

shop/templates/shop/wishlist.html
{% extends 'base.html' %}
{% load static %}
{%block content %}

	<!-- Breadcrumbs -->
	<div class="breadcrumbs">
		<div class="container">
			<div class="row">
				<div class="col-12">
					<div class="bread-inner">
						<ul class="bread-list">
							<li><a href="{% url 'company:home'%}">Home<i class="ti-arrow-right"></i></a></li>
							<li><a href="{% url 'shop:shop' %}">Shop<i class="ti-arrow-right"></i></a></li>
							<li class="active">Wishlist</li>
						</ul>
					</div>
				</div>
			</div>
		</div>
	</div>
	<!-- End Breadcrumbs -->

	<!-- Shopping Cart -->
	{% if wishlist %}
	{% for product in wishlist %}
	<div class="shopping-cart section">
		<div class="container">
			<div class="row">
				<div class="col-12">
					<!-- Shopping Summery -->
					<table class="table shopping-summery">
						<thead>
							<tr class="main-hading">
								<th>PRODUCT</th>
								<th>NAME</th>
								<th class="text-center">UNIT PRICE</th>
								<th class="text-center">VIEW PRODUCT</th>
								<th class="text-center">REMOVE</th>
							</tr>
						</thead>
						<tbody>
							<tr id="remove">
								<td class="image" data-title="No"><img src="{{product.product.images.first.image.url}}" alt="#"></td>
								<td class="product-des" data-title="Description">
									<p class="product-name"><a href="{{product.product.get_absolute_url}}">{{product.product.name}}</a></p>
									<p class="product-des">{{product.product.short_descriptions}}</p>
								</td>
								<td class="price" data-title="Price"><span>
									{% if product.product.discount_price %}
                                        ${{product.product.discount_price}}
                                    {% else %}
                                        ${{product.product.price}}
                                    {% endif %} </span></td>
								<td class="total-amount"><a href="{{product.product.get_absolute_url}}"><i class="ti-eye remove-icon"></i></a></td>
								<td class="action" data-title="Remove"><button>
									<span id="like" attr_id="{{product.product.pk}}" class="ti-trash remove-icon" title="Remove From Wishlist" action_url="{% url 'shop:add_to_wishlist' %}"></span>
								</button></td>
							</tr>
						</tbody>
					</table>
					<!--/ End Shopping Summery -->
				</div>
			</div>

		</div>
	</div>
    {% endfor %}
    {% else %}
    <div class="container"  style="margin-top:100px">
        <div class="row">
            <div class="col-12">
                <div class="section-title">
                    <h2>Your Wishlist is empty...!</h2>
                </div>
				<div class="section-title">
					<h6><a style="color:red" href="{% url 'shop:shop'%}">Go to Shop <i class="ti-arrow-right"></i></a>
					</h6>
				</div>
            </div>
        </div>
	</div>
    {% endif %}
	<!--/ End Shopping Cart -->
{% endblock %}
{% block footer %}
<script src="{% static 'shop/js/like.js' %}"></script>
<script src="{% static 'frontend/js/jquery.cookie.min.js' %}"></script>
{% endblock%}